/*  
  * File:   easyosk.h 
  * Author: joris 
  * 
  * Created on 21 augustus 2009, 13:07 
  */ 
  
 #ifndef _EASYOSK_H 
 #define _EASYOSK_H 
  
 #include <pspkernel.h> 
 #include <pspdisplay.h> 
 #include <pspgu.h> 
 #include <psputility.h> 
 #include <string.h> 
  
 class EasyOsk { 
 public: 
     EasyOsk(); 
     virtual ~EasyOsk(); 
  
     /** 
      * Runs the actual osk. 
      * 
      * char buf[32]; 
      * osk.GetString(buf,32); 
      * 
      * @params text - pointer to a buffer where to store the data. 
      * @params size - maximum size of the buffer. 
      * @params initial - optional initial text. 
      * 
      * @return 0 on success otherwise psp error code. 
      */ 
     int GetString(char * buf, unsigned int size, const char * initial = ""); 
  
     void SetDescription(const char * description); 
     void SetLines(int lines = 1); 
  
     /** Inits the GU with the recommanded settings. Should be usable for most 
      * applications. (compatible with intrafont) 
      */ 
     void InitGU(); 
  
     /** 
      * Terminates the GU. 
      */ 
     void TermGU(); 
  
 private: 
     SceUtilityOskParams params; 
     SceUtilityOskData data; 
     unsigned short desc[128]; 
 }; 
  
 #endif  /* _EASYOSK_H */ 
 