#pragma once

#include <pspctrl.h>
#include "intrafont.h"

#include "GraphicsObject.h"
#include "Cursor.h"
#include "CellManager.h"

enum PspLifeState{
	PspLifeStateStart,
	PspLifeStateMenu,
	PspLifeStateGame,
	PspLifeStateHelp,
	PspLifeStateCredits
};

class GameApp
{
public:
	GameApp();
	~GameApp();

	void initalise();
	void update();
	void render();

	void stop();
	void unload();

	bool running();

private:
	bool mRunning;
	bool mLoaded;

	bool mPauzed;

	unsigned char mMenuWidth;
	unsigned char mMenuHeight;
	unsigned char mMenuItem;

	unsigned short mCpuSpeed;

	PspLifeState mState;

	GraphicsObject mGfx;
	CellManager mCellMgr;
	Cursor mCursor;

	SceCtrlData pad;

	intraFont *mFont;
};
