#include "GraphicsObject.h"

#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspgu.h>

unsigned int GraphicsObject::list[262144];

void *GraphicsObject::mDrawBuffer=0;
void *GraphicsObject::mDispBuffer=0;
void *GraphicsObject::mDepthBuffer=0;

GraphicsObject::GraphicsObject()
{
}

GraphicsObject::~GraphicsObject()
{
}

void GraphicsObject::initGraphics()
{
	pspDebugScreenInit();
	sceGuInit();
	sceGuStart(GU_DIRECT,list);

	mDrawBuffer=(void*)0;
	mDispBuffer=(void*)0x88000;
	mDepthBuffer=(void*)0x110000;
	sceGuDrawBuffer(GU_PSM_8888,mDrawBuffer,512);
	sceGuDispBuffer(480,272,mDispBuffer,512);
	sceGuDepthBuffer(mDepthBuffer,512);
	sceGuOffset(2048 - (480/2),2048 - (272/2));

	// create a viewport centered at 2048,2048 width 480 and height 272
	sceGuViewport(2048,2048,480,272);
	sceGuDepthRange(0xc350,0x2710);

	sceGuScissor(0,0,480,272);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0);

	sceGuFinish();
	// wait untill the list has finished.
	sceGuSync(0,0);
	// turn on the display
	sceGuDisplay(GU_TRUE);
}

void GraphicsObject::startFrame()
{
	pspDebugScreenSetOffset((int)mDispBuffer);
	sceGuStart(GU_DIRECT,list);
	sceGuClearColor(0xff222222);
	sceGuClearDepth(0);
	sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
}

void GraphicsObject::endFrame()
{
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();

	mDispBuffer=mDrawBuffer;
	mDrawBuffer=sceGuSwapBuffers();	
}
