#include "Square.h"

#include <pspgu.h>

Square::Square(void)
{
	mColor=0xF000;
	mWidth=mHeight=1;
	mPosX=mPosY=0;
	mNeedsUpdate=1;
}

Square::~Square(void)
{
}

void Square::setColor(unsigned short color)
{
	mColor=color;
	mNeedsUpdate=1;
}

void Square::setPosition(short x,short y)
{
	mPosX=x;
	mPosY=y;
	mNeedsUpdate=1;
}

void Square::setDimention(short width,short height)
{
	mWidth=width;
	mHeight=height;
	mNeedsUpdate=1;
}

void Square::render()
{
	if(mNeedsUpdate)
		_updateVertices();

	sceGuDrawArray(GU_SPRITES, GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, 0, vertices);
}

void Square::_updateVertices()
{
	vertices[0].color=mColor;
	vertices[0].x=mPosX;
	vertices[0].y=mPosY;
	vertices[0].z=0;
	vertices[1].color=mColor;
	vertices[1].x=mPosX+mWidth;
	vertices[1].y=mPosY+mHeight;
	vertices[1].z=0;
	mNeedsUpdate=0;
}
