#include <pspkernel.h>
#include <pspdebug.h>

#include "GameApp.h"

/* Define the module info section */
PSP_MODULE_INFO("PSPLife", 0, 1, 1);
PSP_HEAP_SIZE_KB(1024*10);
/* Define the main thread's attribute value (optional) */
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

int exit_callback(int arg1, int arg2, void *common) {
	sceKernelExitGame();
	return 0;
}


int CallbackThread(SceSize args, void *argp) {
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}


int SetupCallbacks(void) {
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);   //als er foutenzijn dan  kan het hieraanliggen
	if(thid >= 0) {
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
} 



int main(int argc, char *argv[])
{
	SetupCallbacks();
	pspDebugScreenInit();
	pspDebugScreenPrintf("Hello world");

	GameApp *game=new GameApp();

	game->initalise();

	while(game->running())
	{
		game->update();
		game->render();				
	}

	game->unload();

	delete game;

	sceKernelExitGame();
	return 0;
}
